Index: trunk/kernel/syscalls/sys_thread_detach.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_detach.c	(revision 1)
+++ trunk/kernel/syscalls/sys_thread_detach.c	(revision 23)
@@ -1,15 +1,16 @@
 /*
- * kern/sys_thread_detach.c - detach a joinable thread
+ * sys_thread_detach.c - detach a joinable thread
  * 
- * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Authors   Alain Greiner (2016,2017)
+ *
  * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-kernel.
+ * This file is part of ALMOS-MKH.
  *
- * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -17,69 +18,67 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <list.h>
+#include <hal_types.h>
+#include <hal_remote.h>
+#include <hal_special.h>
 #include <thread.h>
-#include <kmem.h>
-#include <kmagics.h>
 #include <errno.h>
-#include <task.h>
-#include <spinlock.h>
+#include <printk.h>
 
-int sys_thread_detach (pthread_t tid)
+//////////////////////////////////////
+int sys_thread_detach( trdid_t trdid )
 {
-	register struct task_s *task;
-	struct thread_s *target_th;
-	uint_t state;
-	error_t err;
+    xptr_t       target_xp;
+	thread_t   * target_ptr;
+    cxy_t        target_cxy;
+    ltid_t       target_ltid;
+    uint32_t     flags;
 
-	task = current_task;
+	thread_t   * this    = CURRENT_THREAD;
+    process_t  * process = this->process;
 
-	if(tid > task->max_order)
+    // get target thread ltid and cxy
+    target_ltid = LTID_FROM_TRDID( trdid );
+    target_cxy  = CXY_FROM_TRDID( trdid );
+
+    // check trdid argument
+	if( (target_ltid >= CONFIG_THREAD_MAX_PER_CLUSTER) || cluster_is_undefined( target_cxy ) )  
 	{
-		err = EINVAL;
-		goto fail_arg;
-	}
- 
-	spinlock_lock(&task->th_lock);
-
-	target_th = task->th_tbl[tid];
-   
-	if((target_th == NULL)                 ||
-	   (target_th->signature != THREAD_ID) || 
-	   (target_th->info.attr.key != tid))
-	{
-		err = ESRCH;
-		goto fail_srch;
-	}
-  
-	if(!(thread_isJoinable(target_th)))
-	{
-		err = EINVAL;
-		goto fail_not_joinable;
-	}
-  
-	err = 0;
-
-	spinlock_lock(&target_th->lock);
-
-	thread_clear_joinable(target_th);
-
-	if((target_th->info.join == NULL) && 
-	   !(state = wait_queue_isEmpty(&target_th->info.wait_queue)))
-	{
-		wakeup_one(&target_th->info.wait_queue, WAIT_ANY);
+        printk("\n[ERROR] in %s : illegal trdid argument\n", __FUNCTION__ );
+		this->errno = EINVAL;
+		return -1;
 	}
 
-	spinlock_unlock(&target_th->lock);
-  
-fail_not_joinable:
-fail_srch:
-	spinlock_unlock(&task->lock);
+    // get extended pointer on target thread
+	target_xp  = thread_get_xptr( process->pid , trdid );
 
-fail_arg:
-	current_thread->info.errno = err;
-	return err;
-}
+    if( target_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : target thread not found\n", __FUNCTION__ );
+        this->errno = ESRCH;
+        return -1;
+    }
+
+    // get local pointer on target thread
+    target_ptr = (thread_t *)GET_PTR( target_xp );
+
+    // get target thread flags
+    flags = hal_remote_lw( XPTR( target_cxy , &target_ptr->flags ) );
+
+    // check target thread joinable
+    if( flags & THREAD_FLAG_DETACHED )
+    {
+        printk("\n[ERROR] in %s : target thread not joinable\n", __FUNCTION__ );
+        this->errno = EINVAL; 
+        return -1;
+    }
+
+    // atomically set the thread DETACHED flag
+    hal_remote_atomic_or( XPTR( target_cxy , &target_ptr->flags ) , THREAD_FLAG_DETACHED );
+
+	return 0;
+
+}  // end sys_thread_detach()
